package com.jaworski.security.handbook;

import java.math.BigInteger;
import java.security.SecureRandom;

public class FindRelativelyPrime {
 public static void main(String[] args) {
  if(args.length != 1) {
   String err = "Usage: java ";
   err += "com.jaworski.security.handbook.FindRelativelyPrime ";
   err += "number";
   System.out.println(err);
   System.exit(0);
  }
  try {
   BigInteger n = new BigInteger(args[0]);
   int len = n.bitLength();
   SecureRandom rnd = new SecureRandom();
   BigInteger one = new BigInteger("1");
   BigInteger i;
   do {
    i = new BigInteger(len,rnd);
    i = i.mod(n);
    System.out.println("Trying "+i+" ...");
   } while(!n.gcd(i).equals(one)); 
   System.out.println(""+i+" is relatively prime to "+n+"."); 
  }catch(NumberFormatException e) {
   String err = "Error: arg[0] is invalid.";
   System.out.println(err);
  }
 }
}
