
package com.jaworski.security.handbook;

import java.math.BigInteger;
import java.security.SecureRandom;

public class RSASetup {
 public static void main(String[] args) {
  int bitLength = 40;
  int certainty = 50;
  SecureRandom rnd = new SecureRandom();
  BigInteger p = new BigInteger(bitLength,certainty,rnd);
  System.out.println("p is "+p);
  BigInteger q = new BigInteger(bitLength,certainty,rnd);
  System.out.println("q is "+q);
  BigInteger n = p.multiply(q);
  System.out.println("n is "+n);
  BigInteger one = new BigInteger("1");
  BigInteger m = p.subtract(one).multiply(q.subtract(one));
  BigInteger e;
  do {
   e = new BigInteger(m.bitLength(),rnd);
   e = e.mod(m);
  } while(!m.gcd(e).equals(one));   
  System.out.println("e is "+e);
  BigInteger d = e.modInverse(m);
  System.out.println("d is "+d);
 }
}