package com.jaworski.security.handbook;

import java.io.*;
import java.security.*;
import javax.crypto.*;

public class BlowfishEncryptConsoleApp {
 public static void main(String[] args) {
  String help = "Usage: java com.jaworski.security.handbook.";
  help += "BlowfishEncryptConsoleApp plaintextfile ciphertextfile";
  if(args.length != 2) System.out.println(help);  
  else blowfishEncrypt(args[0],args[1]);
 }
 public static void blowfishEncrypt(String f1, String f2) {
  // Generate a key
  SecretKey key = null;
  try {
   // Does a BlowfishKey.ser file exist?
   ObjectInputStream keyFile = new ObjectInputStream(
    new FileInputStream("BlowfishKey.ser"));
   key = (SecretKey) keyFile.readObject();
   keyFile.close();
  }catch(FileNotFoundException e) {
   // If not, generate and save a new key.
   try {
    KeyGenerator keygen = KeyGenerator.getInstance("Blowfish");
    key = keygen.generateKey();
    ObjectOutputStream keyFile = new ObjectOutputStream(
     new FileOutputStream("BlowfishKey.ser"));
    keyFile.writeObject(key);
    keyFile.close();
   }catch(NoSuchAlgorithmException ex) {
    System.out.println("Blowfish key generator not found.");
    System.exit(0);
   }catch(IOException ex) {
    System.out.println("Error saving key.");
    System.exit(0);
   }
  }catch(Exception e) {
    System.out.println("Error reading key.");
    System.exit(0);  
  }
  // Create a cipher
  Cipher cipher = null;
  try {
   cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
   cipher.init(Cipher.ENCRYPT_MODE,key);
  }catch(InvalidKeyException e) {
   System.out.println("Key is invalid.");
   System.exit(0);   
  }catch(Exception e) {
   System.out.println("Error creating cipher.");
   System.exit(0);
  }
  // Read and encrypt file.
  try {
   BufferedInputStream in = new BufferedInputStream(
    new FileInputStream(f1));
   CipherOutputStream out = new CipherOutputStream( 
    new BufferedOutputStream(new FileOutputStream(f2)),
    cipher);
   // Read the file and encrypt
   int i;
   do {
    i = in.read();
    if(i != -1) out.write(i);
   } while(i != -1);
   in.close();
   out.close();   
  }catch(IOException e) {
   System.out.println("Error reading/encrypting.");
  }
 }
}
