package com.jaworski.security.handbook;

// Provide a static implementation of the Caesar cipher.
public class CaesarCipher {
 // Encrypt a String
 public static String encrypt(String s, int key) {
  String returnValue = "";
  for(int i=0;i<s.length();++i) {
   char c = s.charAt(i);
   c = encrypt(c,key);
   returnValue += String.valueOf(c);
  }
  return returnValue;
 }
 // Decrypt a String
 public static String decrypt(String s, int key) {
  return encrypt(s,-key);
 }
 // Encrypt a single character
 public static char encrypt(char c, int key) {
  if(c >= 'a' && c <= 'z') c=Character.toUpperCase(c);
  if(c >= 'A' && c <= 'Z') c=rotate(c,key);
  return c;
 }
 // Decrypt a single character
 public static char decrypt(char c, int key) {
  if(c<'A' || c>'Z') return c;
  else return rotate(c,-key);
 }
 // Perform the alphabetic rotation
 private static char rotate(char c, int key) {
  key = key % 26;
  int n = (c - 'A' + key) % 26;
  if(n < 0) n += 26;
  return (char) (n + 'A');
 }
}