package com.jaworski.security.handbook;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class CaesarCipherApplet extends Applet {
 // Declare GUI elements
 private TextArea plainText = new TextArea(5,50);
 private TextArea cipherText = new TextArea(5,50);
 private Choice keyChoice = new Choice();
 private Button encrypt = new Button("Encrypt");
 private Button decrypt = new Button("Decrypt");
 
 // Define key
 private int key = 0;
 
 public CaesarCipherApplet() {
  // Setup key choices
  for(int i=0;i<26;++i) 
   keyChoice.add(""+i);
  // Layout applet
  layoutApplet();
  // Add event handlers
  keyChoice.addItemListener(new ChoiceHandler());
  encrypt.addActionListener(new ButtonHandler());
  decrypt.addActionListener(new ButtonHandler());
  // Display applet
  resize(400,400);
 }
 private void layoutApplet() {  
  // All these panels are used so that the applet displays 
  // well under Navigator and Internet Explorer.
  Panel keyPanel = new Panel();
  keyPanel.add(new Label("Key: "));
  keyPanel.add(keyChoice);
  keyPanel.add(encrypt);
  keyPanel.add(decrypt);
  Panel textPanel = new Panel();
  Panel textPanel1 = new Panel();
  Panel textPanel2 = new Panel();
  textPanel1.add(new Label("     Plain Text:     "));
  textPanel1.add(plainText);
  textPanel2.add(new Label("     Cipher Text:     "));
  textPanel2.add(cipherText);
  textPanel.setLayout(new GridLayout(2,1));
  textPanel.add(textPanel1);
  textPanel.add(textPanel2);
  setLayout(new BorderLayout());
  add("North",keyPanel);
  add("Center",textPanel);
}
 class ChoiceHandler implements ItemListener {
  // Set the key based on the selected choice.
  public void itemStateChanged(ItemEvent e) {
   key = new Integer(keyChoice.getSelectedItem()).intValue();
  }
 }
 class ButtonHandler implements ActionListener {
  // Handle the Encrypt and Decrypt buttons
  public void actionPerformed(ActionEvent e) {
   if(e.getActionCommand().equals(encrypt.getLabel())) 
    cipherText.setText(CaesarCipher.encrypt(plainText.getText(),key));
   else if(e.getActionCommand().equals(decrypt.getLabel())) 
    plainText.setText(CaesarCipher.decrypt(cipherText.getText(),key));
  }
 }
}
