package com.jaworski.security.handbook;

import java.security.*;
import java.security.spec.*;

public class DSAKeyTranslatorApp { 
 public static void main(String[] args) 
   throws NoSuchAlgorithmException, InvalidKeySpecException {
  // Generate a 512-bit DSA key pair
  KeyPairGenerator kpg = KeyPairGenerator.getInstance("DSA");
  kpg.initialize(512);
  KeyPair keys = kpg.genKeyPair();
  // Obtain the private and public keys
  PrivateKey priKey = keys.getPrivate();
  PublicKey pubKey = keys.getPublic();
  // Convert the PrivateKey into a DSAPrivateKeySpec object
  KeyFactory kf = KeyFactory.getInstance("DSA");
  DSAPrivateKeySpec dsaPriKeySpec = (DSAPrivateKeySpec) 
   kf.getKeySpec(priKey,DSAPrivateKeySpec.class);
  // Convert the PublicKey into a DSAPublicKeySpec object
  DSAPublicKeySpec dsaPubKeySpec = (DSAPublicKeySpec) 
   kf.getKeySpec(pubKey,DSAPublicKeySpec.class);
  // Print the keys
  System.out.println("\nDSA Private Key");
  System.out.println("\nx = "+dsaPriKeySpec.getX());
  System.out.println("\nDSA Public Key");
  System.out.println("\ng = "+dsaPubKeySpec.getG());
  System.out.println("\np = "+dsaPubKeySpec.getP());
  System.out.println("\nq = "+dsaPubKeySpec.getQ());
  System.out.println("\ny = "+dsaPubKeySpec.getY());
 }
}
