import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import java.util.*;

public class DisplayRequestServlet extends HttpServlet {
 public void doGet(HttpServletRequest req, HttpServletResponse resp)
   throws ServletException, java.io.IOException {
  resp.setContentType("text/html");
  PrintWriter out = resp.getWriter();
  displayHead(out,"DisplayRequestServlet");
  openBody(out);
  displayRequest(out,req);
  closeBody(out);
 }
 public void displayHead(PrintWriter out, String title) {
   out.println("<HTML><HEAD><TITLE>"+title+"</TITLE></HEAD>");
 }
 public void openBody(PrintWriter out) {
  out.println("<BODY>");
 }
 public void closeBody(PrintWriter out) {
  out.println("</BODY></HTML>");
 }
 public void displayRequest(PrintWriter out, HttpServletRequest req) {
  displayLine(out,"Authentication type: "+req.getAuthType());
  displayLine(out,"Context path: "+req.getContextPath());
  displayLine(out,"Method: "+req.getMethod());
  displayLine(out,"Path information: "+req.getPathInfo());
  displayLine(out,"Path translated: "+req.getPathTranslated());
  displayLine(out,"Query string: "+req.getQueryString());
  displayLine(out,"Remote user: "+req.getRemoteUser());
  displayLine(out,"Remote session ID: "+req.getRequestedSessionId());
  displayLine(out,"Remote URI: "+req.getRequestURI());
  displayLine(out,"Servlet path: "+req.getServletPath());
  displayLine(out,"Session ID from cookie: "+req.isRequestedSessionIdFromCookie());
  displayLine(out,"Session ID from URL: "+req.isRequestedSessionIdFromURL());
  displayLine(out,"Session valid: "+req.isRequestedSessionIdValid());
  displayCookies(out,req);
  displayHeaders(out,req);
 }
 public void displayLine(PrintWriter out, String s) {
  out.println(s+"<BR>");
 }
 public void displayCookies(PrintWriter out, HttpServletRequest req) {
  Cookie[] cookies = req.getCookies();
  if(cookies != null) {
   displayLine(out,"Cookies:");
   for(int i=0;i<cookies.length;++i) {
    displayLine(out,"&nbsp;Cookie "+i+": ");
    displayLine(out,"&nbsp;&nbsp;Comment: "+cookies[i].getComment());
    displayLine(out,"&nbsp;&nbsp;Domain: "+cookies[i].getDomain());
    displayLine(out,"&nbsp;&nbsp;Maximum age (in seconds): "+cookies[i].getMaxAge());
    displayLine(out,"&nbsp;&nbsp;Name: "+cookies[i].getName());
    displayLine(out,"&nbsp;&nbsp;Path: "+cookies[i].getPath());
    displayLine(out,"&nbsp;&nbsp;Secure: "+cookies[i].getSecure());
    displayLine(out,"&nbsp;&nbsp;Value: "+cookies[i].getValue());
    displayLine(out,"&nbsp;&nbsp;Version: "+cookies[i].getVersion());
   }
  }
 }
 public void displayHeaders(PrintWriter out, HttpServletRequest req) {
  Enumeration headerNames = req.getHeaderNames();
  if(headerNames != null) {
   displayLine(out,"Headers:");
   while(headerNames.hasMoreElements()) {
    String headerName = (String) headerNames.nextElement();
    displayLine(out,"&nbsp;"+headerName+": "+req.getHeader(headerName));
   }
  }
 }
}